/*****************************************************************************
 * ADSP_SC573_SSL_Core0.c
 *****************************************************************************/

#include <sys/platform.h>
#include <sys/adi_core.h>
#include "adi_initialize.h"
#include "ADSP_SC573_SSL_Core0.h"

int main()
{

	adi_initComponents();
	
	//Configuring the SPU secure registers for boot peripheral to do secure access to memory.

	*pREG_SPU0_SECUREP74= 0x3; //SPI2_Rx_DMA
	*pREG_SPU0_SECUREP56= 0x3; //UART0_Rx_DMA
	*pREG_SPU0_SECUREP4= 0x3; //LP0_Rx_DMA
	*pREG_SPU0_SECUREP102= 0x3; //MDMA0_SRC
	*pREG_SPU0_SECUREP103= 0x3; //MDMA0_DST

	//Initialize the LED
	Init_LEDs();

	for(i=0;i<5;i++)
	{

			*pREG_PORTE_DATA_SET=(((1<<BITP_PORT_DATA_PX15) & BITM_PORT_DATA_PX15));

			delay(5000000);

			*pREG_PORTE_DATA_CLR = (((1<<BITP_PORT_DATA_PX15) & BITM_PORT_DATA_PX15));

			delay(5000000);
		}

	adi_rom_Boot((unsigned int *)0x60080000,0,0,0,0x10207);			//ROM API is calling the Image stored in Sector 8 of the SPI flash

	return 0;
}

void Init_LEDs(void)
{
	//LED 17
	*pREG_PORTE_FER_CLR = (((1<<BITP_PORT_DATA_PX15) & BITM_PORT_DATA_PX15));

	*pREG_PORTE_DIR_SET = (((1<<BITP_PORT_DATA_PX15) & BITM_PORT_DATA_PX15));

	*pREG_PORTE_DATA_CLR =(((1<<BITP_PORT_DATA_PX15) & BITM_PORT_DATA_PX15));
}

void delay(int n)
{
	while(n--);
}

